VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Address Book-to-HTML Convertor"
   ClientHeight    =   1575
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7380
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1575
   ScaleWidth      =   7380
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cbxAddressBook 
      Height          =   315
      Left            =   1440
      TabIndex        =   7
      Top             =   120
      Width           =   4575
   End
   Begin VB.CommandButton cmdView 
      Caption         =   "&View"
      Height          =   375
      Left            =   6120
      TabIndex        =   6
      Top             =   1080
      Width           =   975
   End
   Begin MSComDlg.CommonDialog dlgFileDialog1 
      Left            =   120
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
      CancelError     =   -1  'True
      DefaultExt      =   ".txt"
      DialogTitle     =   "Open AddressBook"
      Filter          =   "*.txt"
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "&Browse"
      Height          =   375
      Left            =   6120
      TabIndex        =   4
      Top             =   600
      Width           =   975
   End
   Begin VB.ListBox lbxNicknameList 
      Height          =   255
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   1200
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "&Convert"
      Default         =   -1  'True
      Height          =   375
      Left            =   6120
      TabIndex        =   1
      Top             =   120
      Width           =   975
   End
   Begin VB.Label lblStatus 
      Alignment       =   1  'Right Justify
      Caption         =   "Status:"
      Height          =   255
      Left            =   840
      TabIndex        =   5
      Top             =   600
      Width           =   495
   End
   Begin VB.Label lblStatusText 
      BorderStyle     =   1  'Fixed Single
      Height          =   495
      Left            =   1440
      TabIndex        =   3
      Top             =   600
      Width           =   4575
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Address Book:"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Public a$
Public noteline$
Public addressbook$
Public writeline%
Public noteretrieved%
Public ctr%
Public nickname$
Public quote$
Public at$
Public br$
Public proc$
Public eudbreak$
Public inputstring$
Public inifile$
'Public htmlfile$
Public addrformat%
Public pagetitle$
Public booktitle$

Public emailaddress$
Public recipientname$
Public recipientaddress$
Public recipientphone$
Public recipientfax$
Public recipientnote$

Public usea%
Public useb%
Public usec%
Public used%
Public usee%
Public usef%
Public useg%
Public useh%
Public usei%
Public usej%
Public usek%
Public usel%
Public usem%
Public usen%
Public useo%
Public usep%
Public useq%
Public user%
Public uses%
Public uset%
Public useu%
Public usev%
Public usew%
Public usex%
Public usey%
Public usez%

Public useda%
Public usedb%
Public usedc%
Public usedd%
Public usede%
Public usedf%
Public usedg%
Public usedh%
Public usedi%
Public usedj%
Public usedk%
Public usedl%
Public usedm%
Public usedn%
Public usedo%
Public usedp%
Public usedq%
Public usedr%
Public useds%
Public usedt%
Public usedu%
Public usedv%
Public usedw%
Public usedx%
Public usedy%
Public usedz%

Public newindex%
Public indexname$



Private Sub cmdConvert_Click()
    proc$ = "cmdConvert_Click()"
    lblStatusText.Caption = "Working..."
    ResetFlags
    ctr% = 0
    cmdConvert.Enabled = False
    cmdOpen.Enabled = False
    cmdView.Enabled = False
    addressbook$ = cbxAddressBook.Text
    DoEvents
    If Len(addressbook$) = 0 Then
        MsgBox "Must enter name of Address Book file to convert", vbCritical, App.Title
        lblStatusText.Caption = "Invalid Address Book filename"
        cmdOpen.Enabled = True
        Exit Sub
    End If
    On Error GoTo ErrorTrap
    Open addressbook$ For Input As #1
    htmlfile$ = Mid$(addressbook$, 1, Len(addressbook$) - 4) & ".htm"
    proc$ = "cmdConvert_Click()"
    'read through file adding nicknames to listbox
    While Not EOF(1)
        Line Input #1, a$
        If Len(a$) > 0 Then
            If Mid$(a$, 1, 6) = "alias " Then
                ExtractNickname
                proc$ = "cmdConvert_Click()"
                lbxNicknameList.AddItem (nickname$)
                SetIndex
            End If
        End If
    Wend
    Close #1
    nicknamecount% = lbxNicknameList.ListCount
    WriteHeader
    
    For n% = 1 To nicknamecount%
    'For n% = 1 To 25
        nicknamekey$ = lbxNicknameList.List(n% - 1)
        'MsgBox "Nicknamekey: " & nicknamekey$
        Open addressbook$ For Input As #1
        While Not EOF(1)
            Line Input #1, a$
            If Mid$(a$, 1, 6) = "alias " Then
                ExtractNickname
                proc$ = "cmdConvert_Click()"
                If Mid$(a$, 7, 1) = quote$ Then
                    addrstart% = InStr(8, a$, quote$) + 1
                Else
                    addrstart% = InStr(8, a$, " ") + 1
                End If
                emailaddress$ = Mid$(a$, addrstart%, Len(a$))
                proc$ = "cmdConvert_Click()"
                If nickname$ = nicknamekey$ Then
                    'extract address(es)
                    If MultipleAddress(emailaddress$) Then
                        'MsgBox nickname$ & "Contains multiple addresses"
                        'emailaddress$ = "[Multiple Addresses]"
                        emailaddress$ = MakeMultipleAddress(emailaddress$)
                        proc$ = "cmdConvert_Click()"
                        emailaddress$ = "<font size=small>" & emailaddress$ & "</font>"
                    Else
                        'emailaddress$ = "[Single Address]"
                        ExtractEmailAddress
                        proc$ = "cmdConvert_Click()"
                    End If
                    'emailaddress$ = "dummy@address.org"
                    If Not EOF(1) Then Line Input #1, a$
                    If Mid$(a$, 1, 5) = "note " Then
                        
                        If Mid$(a$, 6, 1) = quote$ Then
                            notestart% = InStr(7, a$, quote$) + 1
                        Else
                            notestart% = InStr(7, a$, " ") + 1
                        End If
                        noteline$ = Mid$(a$, notestart%, Len(a$))
                        
                        'noteline$ = a$
                        ReadNoteLine
                        proc$ = "cmdConvert_Click()"
                    Else
                        'clear old recipient info
                        recipientname$ = ""
                        recipientaddress$ = ""
                        recipientphone$ = ""
                        recipientfax$ = ""
                        recipientnote$ = ""
                    End If
                    'Add procedure call to determine if
                    '   this character has been used.
                    '   Procedure should set a flag and string
                    'checkindex
                    WriteHTMLLine
                    proc$ = "cmdConvert_Click()"
                    
                    ' I used the following progress meter instead of adding the
                    'VB5 ProgressBar object because it ProgressBar requires
                    'comctl32.ocx (574k)
                    If ctr% Mod 5 = 0 Then
                        lblStatusText.Caption = "Converted " & Str$(ctr%) & " of " & Str$(nicknamecount%) & " ..."
                        DoEvents
                    End If
                End If
            End If
        Wend
        Close #1
    Next n%
    GoTo EndConvert
    
ErrorTrap:
    Select Case Err
        Case 53
            MsgBox "Specified Address Book does not exist." & vbCrLf & "Filename: " & addressbook$, vbCritical, App.Title
            lblStatusText.Caption = "Invalid Address Book filename"
            'cbxAddressBook.Text = ""
            cbxAddressBook.SetFocus
            cmdOpen.Enabled = True
            SendKeys "{home}+{end}"
            cmdOpen.SetFocus
        Case 62
            GoTo EndConvert
        Case 32755
            Exit Sub
        Case Else
            DisplayError
    End Select
    Close #1
    Close #2
    cmdConvert.Enabled = True
    If Not cmdOpen.Enabled Then
        cmdOpen.Enabled = True
    End If
    Exit Sub

EndConvert:
    WriteFooter
    proc$ = "cmdConvert_Click()"
    lbxNicknameList.Clear
    lblStatusText.Caption = "Done. " & Str$(ctr%) & " Nicknames converted to:" & vbCrLf & htmlfile$
    If ctr% > 0 Then
        UpdateAddressBookList (addressbook$)
        WriteINIFile
    End If
    proc$ = "cmdConvert_Click()"
    cmdConvert.Enabled = True
    cmdView.Enabled = True
    cmdOpen.Enabled = True
    cmdView.SetFocus
End Sub


Private Sub WriteHTMLLine()
proc$ = "WriteHTMLLine()"
        CheckIndex
        Print #2, "<tr>"
        Print #2, "<td>";
        If newindex% Then
            Print #2, "<a name="; quote$; indexname$; quote$; ">";
            Print #2, "<p align="; quote$; "right"; quote$; "><font size="; quote$; "small"; quote$; "><a href="; quote$; "#Top"; quote$; ">TOP</a></font></p>"
            newindex% = False
        End If
        Print #2, "<b>"; nickname$; "</b>";
        If InStr(1, emailaddress$, br$) = 0 Then
            If Len(recipientname$) > 0 Then
                emailaddress$ = "<a href=" & quote$ & "mailto:" & emailaddress$ & " (" & recipientname$ & ")" & quote$ & ">" & emailaddress$ & "</a>"
            Else
                emailaddress$ = "<a href=" & quote$ & "mailto:" & emailaddress$ & quote$ & ">" & emailaddress$ & "</a>"
            End If
            If Len(emailaddress$) > 110 Then
                emailaddress$ = "<font size=small>" & emailaddress$ & "</font>"
            End If
        End If
        Print #2, br$; emailaddress$
        Print #2, "<td valign="; quote$; "top"; quote$; "><font size="; quote$; "small"; quote$; ">"; recipientname$; br$; recipientaddress$; br$;
        If Len(recipientphone$) > 0 Then Print #2, "Phone: " & recipientphone$; br$;
        If Len(recipientfax$) > 0 Then Print #2, "Fax: " & recipientfax$;
        Print #2, "</font>"
        Print #2, "<td valign=top><font size=small>"; recipientnote$; "</font>"
        Print #2, "</tr>"; vbCrLf
        ctr% = ctr% + 1
End Sub




Private Sub cmdOpen_Click()
proc$ = "cmdOpen_Click()"
    On Error GoTo ErrTrap
    cmdView.Enabled = False
    oldfile$ = cbxAddressBook.Text
    Dim dlgBrowse As CommonDialog
    Set dlgBrowse = dlgFileDialog1
    dlgBrowse.DialogTitle = "Open Address Book"
    dlgBrowse.Filter = "Address Books (*.txt)|*.txt|All Files (*.*)|*.*"
    'inputfile$ = ""
    dlgBrowse.ShowOpen
    inputfile$ = dlgBrowse.filename
    'MsgBox "File Title: " & b$
    cbxAddressBook.Text = inputfile$
    lblStatusText.Caption = "Ready"
    cmdConvert.SetFocus
    Exit Sub
ErrTrap:
    If Err = 32755 Then
        cmdOpen.Enabled = True
        cmdConvert.Enabled = True
        cmdView.Enabled = False
        Exit Sub
    End If
    DisplayError
End Sub


Private Sub cmdView_Click()
    ViewPage
End Sub


Private Sub Form_Load()
    proc$ = "Form_Load()"
    cmdView.Enabled = False
    On Error GoTo ErrorTrap
    
    'Set Global Variables
    at$ = "@"
    quote$ = Chr$(34)
    br$ = "<br>"
    eudbreak$ = Chr$(3)
    inifile$ = "nn2htm.ini"
    addressbook$ = "c:\eudora\nndbase.txt"
    
    apppath$ = App.Path
    ChDir (apppath$)
    Open inifile$ For Input As #3
    While Not EOF(3)
        Line Input #3, b$
        If Len(b$) > 0 Then
            If InStr(1, b$, "AddressBook=") = 1 And Len(b$) > 12 Then
                addressbook$ = Mid$(b$, 13, Len(b$))
                UpdateAddressBookList (addressbook$)
            End If
        End If
    Wend
    Close #3
    cbxAddressBook.Text = addressbook$
    lblStatusText.Caption = "Ready"
    pagetitle$ = "Email Addresses"
    Exit Sub
ErrorTrap:
    Select Case Err
        Case 53
            cbxAddressBook.Text = addressbook$
            pagetitle$ = "Email Addresses"
            Exit Sub
        Case 75
            cbxAddressBook.Text = addressbook$
            pagetitle$ = "Email Addresses"
            Exit Sub
        Case Else
            DisplayError
            Close #3
    End Select
End Sub


Private Sub ReadNoteLine()
    proc$ = "ReadNoteLine()"
    'Clear existing data from strings
    recipientname$ = ""
    recipientaddress$ = ""
    recipientphone$ = ""
    recipientfax$ = ""
    recipientnote$ = ""
    
    'Parse note line to retrieve data
    If InStr(1, noteline$, "<fax:") > 0 Then
        faxstart% = InStr(1, noteline$, "<fax:") + 5
        faxend% = InStr(faxstart%, noteline$, ">")
        recipientfax$ = Mid$(noteline$, faxstart%, faxend% - faxstart%)
    End If
    If InStr(1, noteline$, "<phone:") > 0 Then
        phonestart% = InStr(1, noteline$, "<phone:") + 7
        phoneend% = InStr(phonestart%, noteline$, ">")
        recipientphone$ = Mid$(noteline$, phonestart%, phoneend% - phonestart%)
    End If
    If InStr(1, noteline$, "<address:") > 0 Then
        addressstart% = InStr(1, noteline$, "<address:") + 9
        addressend% = InStr(addressstart%, noteline$, ">")
        recipientaddress$ = Mid$(noteline$, addressstart%, addressend% - addressstart%)
        'Replace Eudora-style Line breaks with HTML line breaks
        recipientaddress$ = ReplaceChr3(recipientaddress$)
        proc$ = "ReadNoteLine()"
        'recipientaddress$ = inputstring$
    End If
    If InStr(1, noteline$, "<name:") > 0 Then
        namestart% = InStr(1, noteline$, "<name:") + 6
        nameend% = InStr(namestart%, noteline$, ">")
        recipientname$ = Mid$(noteline$, namestart%, nameend% - namestart%)
    End If
    
    'find last fieldend%
    notestart% = Len(noteline$)
    If nameend% > addressend% And nameend% > phoneend% And nameend% > faxend% Then notestart% = nameend% + 1
    If addressend% > nameend% And addressend% > phoneend% And addressend% > faxend% Then notestart% = addressend% + 1
    If phoneend% > addressend% And phoneend% > nameend% And phoneend% > faxend% Then notestart% = phoneend% + 1
    If faxend% > addressend% And faxend% > phoneend% And faxend% > nameend% Then notestart% = faxend% + 1
    If Len(noteline$) > notestart% Then
        recipientnote$ = Mid$(noteline$, notestart%, Len(noteline$))
        recipinetnote$ = StripBrackets(recipientnote$)
        recipientnote$ = ReplaceChr3(recipientnote$)
        proc$ = "ReadNoteLine()"
    Else
        recipientnote$ = noteline$
    End If
End Sub


Public Sub WriteHeader()
    proc$ = "WriteHeader()"
    If LCase$(Right$(addressbook$, 4)) = ".txt" Then
        bookname$ = Mid$(addressbook$, 1, Len(addressbook$) - 4)
    Else
        bookname$ = addressbook$
    End If
    bookname$ = RootName(bookname$)
    If LCase$(bookname$) = "nndbase" Then
        bookname$ = "Eudora Nicknames"
    End If
    Open htmlfile$ For Output As #2
    Print #2, "<html>"; vbCrLf; "<title>"; pagetitle$; "</title>"
    Print #2, "<body bgcolor="; quote$; "#ffffff"; quote$; ">"
    Print #2, "<a name="; quote$; "Top"; quote$; ">"
    Print #2, "<h1>"; pagetitle$; "</h1>"
    Print #2, "<table border=0>"; vbCrLf; "<tr>"
    Print #2, "<td align="; quote$; "right"; quote$; "><b>Address Book: <br>Date: </b>"
    Print #2, "<td> "; bookname$; br$; Format(Date, "dd-mmm-yyyy")
    Print #2, "</tr>"; vbCrLf; "</table>"; vbCrLf
    WriteIndex
    Print #2, "<center>"
    Print #2, "<table border=1>"
    Print #2, "<tr>"
    Print #2, "<td valign=middle><h3><b>Nickname</b><br>Email Address</h3>"
    Print #2, "<td valign=middle><h3><b>Name</b><br>Address<br>Phone<br>Fax</h3>"
    Print #2, "<td valign=middle align=center><h3><b>Notes</b></h3>"
    Print #2, "</tr>"; vbCrLf
End Sub


Private Sub WriteFooter()
    proc$ = "WriteFooter()"
    Print #2, "</table>"; vbCrLf; "</center>"; vbCrLf
    Print #2, "<p>"; Str$(ctr%); " Entries converted from Address Book: "; addressbook$
    Print #2, "<p>Generated "; "by <b>"; App.Title; "</b> v"; LTrim$(RTrim$(App.Major)); "."; LTrim$(RTrim$(App.Minor)); " <a href="; quote$; "http://www.pobox.com/~agreene/"; quote$; ">&lt;http://www.pobox.com/~agreene/eudora/&gt;</a><br>"
    Print #2, "Maintainer: Anthony E. Greene <a href="; quote$; "mailto:agreene@pobox.com (Anthony E. Greene)?subject=Address Book-to-HTML Convertor Comment"; quote$; ">&lt;agreene@pobox.com&gt;</a>.</p>"
    Print #2, "</body>"; vbCrLf; "</html>"; vbCrLf
    Close #2
End Sub


Private Sub DisplayError()
    MsgBox "Error " & Str$(Err) & ": " & Error$(Err) & vbCrLf & "Procedure: " & proc$
End Sub


Private Sub WriteINIFile()
    proc$ = "WriteINIFile()"
    apppath$ = App.Path
    ChDir (apppath$)
    Open inifile$ For Output As #3
    'Add code to write contents of cbxAddressBook List
    For n% = 1 To cbxAddressBook.ListCount
        currfile$ = cbxAddressBook.List(n% - 1)
        If currfile$ <> addressbook$ Then Print #3, "AddressBook="; currfile$
    Next n%
    Print #3, "AddressBook="; addressbook$
    Close #3
End Sub


Private Function ReplaceChr3(b$) As String
proc$ = "ReplaceChr3()"
    While InStr(1, b$, eudbreak$, vbTextCompare) > 0
        currpos% = InStr(1, b$, eudbreak$, vbTextCompare)
        If currpos% < Len(b$) Then
            b$ = Mid$(b$, 1, currpos% - 1) & br$ & Mid$(b$, currpos% + 1, Len(b$))
        Else
            b$ = Mid$(b$, 1, Len(b$) - 1)
        End If
    Wend
    ReplaceChr3 = b$
End Function
    
    
Private Function MakeMultipleAddress(addr$) As String
proc$ = "MakeMultipleAddress()"
    While InStr(1, addr$, ",") > 0
        currpos% = InStr(1, addr$, ",")
        If currpos% < Len(addr$) And currpos% > 0 Then
            addr$ = Mid$(addr$, 1, currpos% - 1) & eudbreak$ & Mid$(addr$, currpos% + 1, Len(addr$))
        Else
            addr$ = Mid$(addr$, 1, Len(addr$) - 1)
        End If
    Wend
    addr$ = StripBrackets(addr$)
    proc$ = "MakeMultipleAddress()"
    While InStr(1, addr$, eudbreak$) > 0
        currpos% = InStr(1, addr$, eudbreak$)
        If currpos% < Len(addr$) And currpos% > 0 Then
            addr$ = Mid$(addr$, 1, currpos% - 1) & br$ & Mid$(addr$, currpos% + 1, Len(addr$))
        Else
            addr$ = Mid$(addr$, 1, Len(addr$) - 1)
        End If
    Wend
    MakeMultipleAddress = addr$
End Function


Private Sub ExtractNickname()
proc$ = "ExtractNickname()"
    If Mid$(a$, 7, 1) = quote$ Then
        nameend% = InStr(8, a$, quote$) - 1
        namestart% = 8
    Else
        nameend% = InStr(8, a$, " ") - 1
        namestart% = 7
    End If
    nickname$ = Mid$(a$, namestart%, nameend% - namestart% + 1)
End Sub


Private Sub ExtractEmailAddress()
proc$ = "ExtractEmailAddress()"
    'This routine extract the address portion of an single-address alias line

    'If Mid$(a$, 7, 1) = quote$ Then
    '    addrstart% = InStr(8, a$, quote$) + 2
    'Else
    '    addrstart% = InStr(8, a$, " ") + 1
    'End If
    'emailaddress$ = Mid$(a$, addrstart%, Len(a$))
    
    addrformat% = AddressFormat(emailaddress$)
    Select Case addrformat%
        Case 1
        proc$ = "ExtractEmailAddress()"
            'Format: Full Name <user@domain>
            addrstart% = InStr(1, emailaddress$, "<") + 1
            addrend% = InStr(1, emailaddress$, ">")
            emailaddress$ = Mid$(emailaddress$, addrstart%, addrend% - addrstart%)
            'MsgBox "Format: " & Str$(addrformat%) & vbCrLf & "Output Address: " & emailaddress$
        Case 2
        proc$ = "ExtractEmailAddress()"
            'Format: "Full Name" <user@domain>
            addrstart% = InStr(1, emailaddress$, "<") + 1
            addrend% = InStr(1, emailaddress$, ">")
            emailaddress$ = Mid$(emailaddress$, addrstart%, addrend% - addrstart%)
            'MsgBox "Format: " & Str$(addrformat%) & vbCrLf & "Output Address: " & emailaddress$
        Case 3
        proc$ = "ExtractEmailAddress()"
            'Format: user@domain (Full Name)
            addrstart% = 1
            addrend% = InStr(1, emailaddress$, " ")
            emailaddress$ = Mid$(emailaddress$, addrstart%, addrend% - addrstart%)
            'MsgBox "Format: " & Str$(addrformat%) & vbCrLf & "Output Address: " & emailaddress$
        Case 4
        proc$ = "ExtractEmailAddress()"
            'Format: <user@domain> (Full Name)
            addrstart% = InStr(1, emailaddress$, "<") + 1
            addrend% = InStr(1, emailaddress$, ">")
            emailaddress$ = Mid$(emailaddress$, addrstart%, addrend% - addrstart%)
            'MsgBox "Format: " & Str$(addrformat%) & vbCrLf & "Output Address: " & emailaddress$
        Case 5
        proc$ = "ExtractEmailAddress()"
            'Format: user@domain
            'MsgBox "Format: " & Str$(addrformat%) & vbCrLf & "Output Address: " & emailaddress$
        Case 6
        proc$ = "ExtractEmailAddress()"
            'Format: <user@domain>
            addrstart% = InStr(1, emailaddress$, "<") + 1
            addrend% = InStr(1, emailaddress$, ">")
            emailaddress$ = Mid$(emailaddress$, addrstart%, addrend% - addrstart%)
            'MsgBox "Format: " & Str$(addrformat%) & vbCrLf & "Output Address: " & emailaddress$
    End Select
    proc$ = "ExtractEmailAddress()"
    If Right$(emailaddress$, 1) = "," Then
        emailaddress$ = Mid$(emailaddress$, 1, Len(emailaddress$) - 1)
    End If
    'If addrformat% > 0 Then emailaddress$ = "<a href=" & quote$ & "mailto:" & emailaddress$ & quote$ & ">" & emailaddress$ & "</a>"
    'If Len(emailaddress$) > 92 Then
    '    emailaddress$ = "<font size=small>" & emailaddress$ & "</font>"
    'End If
End Sub


Private Function AddressFormat(addr$) As Integer
proc$ = "AddressFormat()"
 If Left$(addr$, 1) = quote$ Then AddressFormat% = 2: Exit Function
 If Left$(addr$, 1) = "<" Then
  If InStr(addr$, "(") > 0 Then
   AddressFormat = 4
  Else
   AddressFormat = 6
  End If
  Exit Function
 End If
 If InStr(addr$, "<") > 0 Then AddressFormat = 1: Exit Function
 If InStr(addr$, "(") > 0 Then AddressFormat = 3: Exit Function
 If InStr(addr$, "@") > 0 Then AddressFormat = 5: Exit Function
 AddressFormat = 0
End Function


Private Function StripBrackets(b$) As String
proc$ = "StripBrackets()"
    While InStr(1, b$, "<") > 0
        currpos% = InStr(1, b$, "<")
        If currpos% <= Len(b$) Then
            b$ = Mid$(b$, 1, currpos% - 1) & "&lt;" & Mid$(b$, currpos% + 1, Len(b$))
        'Else
            'b$ = Mid$(b$, 1, Len(b$) - 1)
        End If
    Wend
    While InStr(1, b$, ">") > 0
        currpos% = InStr(1, b$, ">")
        If currpos% <= Len(b$) Then
            b$ = Mid$(b$, 1, currpos% - 1) & "&gt;" & Mid$(b$, currpos% + 1, Len(b$))
        'Else
            'b$ = Mid$(b$, 1, Len(b$) - 1)
        End If
    Wend
    StripBrackets = b$
End Function


Private Function MultipleAddress(addr$) As Boolean
proc$ = "MultipleAddress()"
    'This function determines whether or not a string contains
    '   more than one email address
    'The string is assumed to be the Address portion of a alias line.
    
    'This test is for a comma appearing prior to the end of the string
    If InStr(1, addr$, ",") > 0 And InStr(1, addr$, ",") < Len(addr$) Then
        'currpos% = InStr(1, addr$, ",")
        'If currpos% < Len(addr$) Then
            'If InStr(currpos% + 1, addr$, ",") > 0 Then
                MultipleAddress = True
                Exit Function
            'End If
        'End If
    End If
    
    'This test is for more than one "@" symbol in the string
    If InStr(1, addr$, "@") > 0 Then
        currpos% = InStr(1, addr$, "@")
        If currpos% < Len(addr$) Then
            If InStr(currpos% + 1, addr$, "@") > 0 Then
                MultipleAddress = True
                Exit Function
            End If
        End If
    End If
    
    'This test is for a non-LineBreak character following a line break in the string
    If InStr(1, addr$, eudbreak$) > 0 Then
        currpos% = InStr(1, addr$, eudbreak$)
        If currpos% < Len(addr$) Then
            'If InStr(currpos% + 1, addr$, eudbreak$) > 0 Then
            If Mid$(addr$, currpos% + 1, 1) <> eudbreak$ Then
                MultipleAddress = True
                Exit Function
            End If
        End If
    End If
    
    'If not caught by any of the above tests, set function to false
    '   and return.
    MultipleAddress = False
End Function


Private Sub UpdateAddressBookList(newfile$)
proc$ = "UpdateAddressBookList()"
    maxitems% = 15
    If cbxAddressBook.ListCount < maxitems% Then
        inlist% = False
        For n% = 1 To cbxAddressBook.ListCount
            currfile$ = cbxAddressBook.List(n% - 1)
            If newfile$ = currfile$ Then
                inlist% = True
                currpos% = cbxAddressBook.ListIndex
            End If
        Next n%
        If Not inlist% Then
            cbxAddressBook.AddItem (newfile$)
        End If
    ElseIf cbxAddressBook.ListCount = maxitems% Then
        'Add code to remove bottom item and add new item to top
    End If
End Sub


Private Function RootName(f$)
    currpos% = 1
    While InStr(currpos%, f$, "\") > 0
        currpos% = InStr(currpos% + 1, f$, "\")
        f$ = Mid$(f$, currpos% + 1, Len(f$))
    Wend
    RootName = f$
End Function


Public Sub WriteIndex()
    Print #2, "<p align="; quote$; "center"; quote$; ">[ ";
    If usea% Then
        Print #2, "<a href="; quote$; "#Index-A"; quote$; ">A</a> | ";
    Else
        Print #2, "A | ";
    End If
    If useb% Then
        Print #2, "<a href="; quote$; "#Index-B"; quote$; ">B</a> | ";
    Else
        Print #2, "B | ";
    End If
    If usec% Then
        Print #2, "<a href="; quote$; "#Index-C"; quote$; ">C</a> | ";
    Else
        Print #2, "C | ";
    End If
    If used% Then
        Print #2, "<a href="; quote$; "#Index-D"; quote$; ">D</a> | ";
    Else
        Print #2, "D | ";
    End If
    If usee% Then
        Print #2, "<a href="; quote$; "#Index-E"; quote$; ">E</a> | ";
    Else
        Print #2, "E | ";
    End If
    If usef% Then
        Print #2, "<a href="; quote$; "#Index-F"; quote$; ">F</a> | ";
    Else
        Print #2, "F | ";
    End If
    If useg% Then
        Print #2, "<a href="; quote$; "#Index-G"; quote$; ">G</a> | ";
    Else
        Print #2, "G | ";
    End If
    If useh% Then
        Print #2, "<a href="; quote$; "#Index-H"; quote$; ">H</a> | ";
    Else
        Print #2, "H | ";
    End If
    If usei% Then
        Print #2, "<a href="; quote$; "#Index-I"; quote$; ">I</a> | ";
    Else
        Print #2, "I | ";
    End If
    If usej% Then
        Print #2, "<a href="; quote$; "#Index-J"; quote$; ">J</a> | ";
    Else
        Print #2, "J | ";
    End If
    If usek% Then
        Print #2, "<a href="; quote$; "#Index-K"; quote$; ">K</a> | ";
    Else
        Print #2, "K | ";
    End If
    If usel% Then
        Print #2, "<a href="; quote$; "#Index-L"; quote$; ">L</a> | ";
    Else
        Print #2, "L | ";
    End If
    If usem% Then
        Print #2, "<a href="; quote$; "#Index-M"; quote$; ">M</a> | ";
    Else
        Print #2, "M | ";
    End If
    If usen% Then
        Print #2, "<a href="; quote$; "#Index-N"; quote$; ">N</a> | ";
    Else
        Print #2, "N | ";
    End If
    If useo% Then
        Print #2, "<a href="; quote$; "#Index-O"; quote$; ">O</a> | ";
    Else
        Print #2, "O | ";
    End If
    If usep% Then
        Print #2, "<a href="; quote$; "#Index-P"; quote$; ">P</a> | ";
    Else
        Print #2, "P | ";
    End If
    If useq% Then
        Print #2, "<a href="; quote$; "#Index-Q"; quote$; ">Q</a> | ";
    Else
        Print #2, "Q | ";
    End If
    If user% Then
        Print #2, "<a href="; quote$; "#Index-R"; quote$; ">R</a> | ";
    Else
        Print #2, "R | ";
    End If
    If uses% Then
        Print #2, "<a href="; quote$; "#Index-S"; quote$; ">S</a> | ";
    Else
        Print #2, "S | ";
    End If
    If uset% Then
        Print #2, "<a href="; quote$; "#Index-T"; quote$; ">T</a> | ";
    Else
        Print #2, "T | ";
    End If
    If useu% Then
        Print #2, "<a href="; quote$; "#Index-U"; quote$; ">U</a> | ";
    Else
        Print #2, "U | ";
    End If
    If usev% Then
        Print #2, "<a href="; quote$; "#Index-V"; quote$; ">V</a> | ";
    Else
        Print #2, "V | ";
    End If
    If usew% Then
        Print #2, "<a href="; quote$; "#Index-W"; quote$; ">W</a> | ";
    Else
        Print #2, "W | ";
    End If
    If usex% Then
        Print #2, "<a href="; quote$; "#Index-X"; quote$; ">X</a> | ";
    Else
        Print #2, "X | ";
    End If
    If usey% Then
        Print #2, "<a href="; quote$; "#Index-Y"; quote$; ">Y</a> | ";
    Else
        Print #2, "Y | ";
    End If
    If usez% Then
        Print #2, "<a href="; quote$; "#Index-Z"; quote$; ">Z</a> ]";
    Else
        Print #2, "Z ]"
    End If
    Print #2, "</p>"; vbCrLf
End Sub


Private Sub SetIndex()
    x$ = LCase$(Mid$(nickname$, 1, 1))
    'MsgBox "Index Test Char: " & x$
    Select Case x$
        Case "a"
            usea% = True
        Case "b"
            useb% = True
        Case "c"
            usec% = True
        Case "d"
            used% = True
        Case "e"
            usee% = True
        Case "f"
            usef% = True
        Case "g"
            useg% = True
        Case "h"
            useh% = True
        Case "i"
            usei% = True
        Case "j"
            usej% = True
        Case "k"
            usek% = True
        Case "l"
            usel% = True
        Case "m"
            usem% = True
        Case "n"
            usen% = True
        Case "o"
            useo% = True
        Case "p"
            usep% = True
        Case "q"
            useq% = True
        Case "r"
            user% = True
        Case "s"
            uses% = True
        Case "t"
            uset% = True
        Case "u"
            useu% = True
        Case "v"
            usev% = True
        Case "w"
            usew% = True
        Case "x"
            usex% = True
        Case "y"
            usey% = True
        Case "z"
            usez% = True
    End Select
End Sub


Public Sub CheckIndex()
    x$ = LCase$(Mid$(nickname$, 1, 1))
    Select Case x$
        Case "a"
            If Not useda% Then
                useda% = True
                newindex% = True
                indexname$ = "Index-A"
            Else
                newindex% = False
            End If
        Case "b"
            If Not usedb% Then
                usedb% = True
                newindex% = True
                indexname$ = "Index-B"
            Else
                newindex% = False
            End If
        Case "c"
            If Not usedc% Then
                usedc% = True
                newindex% = True
                indexname$ = "Index-C"
            Else
                newindex% = False
            End If
        Case "d"
            If Not usedd% Then
                usedd% = True
                newindex% = True
                indexname$ = "Index-D"
            Else
                newindex% = False
            End If
        Case "e"
            If Not usede% Then
                usede% = True
                newindex% = True
                indexname$ = "Index-E"
            Else
                newindex% = False
            End If
        Case "f"
            If Not usedf% Then
                usedf% = True
                newindex% = True
                indexname$ = "Index-F"
            Else
                newindex% = False
            End If
        Case "g"
            If Not usedg% Then
                usedg% = True
                newindex% = True
                indexname$ = "Index-G"
            Else
                newindex% = False
            End If
        Case "h"
            If Not usedh% Then
                usedh% = True
                newindex% = True
                indexname$ = "Index-H"
            Else
                newindex% = False
            End If
        Case "i"
            If Not usedi% Then
                usedi% = True
                newindex% = True
                indexname$ = "Index-I"
            Else
                newindex% = False
            End If
        Case "j"
            If Not usedj% Then
                usedj% = True
                newindex% = True
                indexname$ = "Index-J"
            Else
                newindex% = False
            End If
        Case "k"
            If Not usedk% Then
                usedk% = True
                newindex% = True
                indexname$ = "Index-K"
            Else
                newindex% = False
            End If
        Case "l"
            If Not usedl% Then
                usedl% = True
                newindex% = True
                indexname$ = "Index-L"
            Else
                newindex% = False
            End If
        Case "m"
            If Not usedm% Then
                usedm% = True
                newindex% = True
                indexname$ = "Index-M"
            Else
                newindex% = False
            End If
        Case "n"
            If Not usedn% Then
                usedn% = True
                newindex% = True
                indexname$ = "Index-N"
            Else
                newindex% = False
            End If
        Case "o"
            If Not usedo% Then
                usedo% = True
                newindex% = True
                indexname$ = "Index-O"
            Else
                newindex% = False
            End If
        Case "p"
            If Not usedp% Then
                usedp% = True
                newindex% = True
                indexname$ = "Index-P"
            Else
                newindex% = False
            End If
        Case "q"
            If Not usedq% Then
                usedq% = True
                newindex% = True
                indexname$ = "Index-Q"
            Else
                newindex% = False
            End If
        Case "r"
            If Not usedr% Then
                usedr% = True
                newindex% = True
                indexname$ = "Index-R"
            Else
                newindex% = False
            End If
        Case "s"
            If Not useds% Then
                useds% = True
                newindex% = True
                indexname$ = "Index-S"
            Else
                newindex% = False
            End If
        Case "t"
            If Not usedt% Then
                usedt% = True
                newindex% = True
                indexname$ = "Index-T"
            Else
                newindex% = False
            End If
        Case "u"
            If Not usedu% Then
                usedu% = True
                newindex% = True
                indexname$ = "Index-U"
            Else
                newindex% = False
            End If
        Case "v"
            If Not usedv% Then
                usedv% = True
                newindex% = True
                indexname$ = "Index-V"
            Else
                newindex% = False
            End If
        Case "w"
            If Not usedw% Then
                usedw% = True
                newindex% = True
                indexname$ = "Index-W"
            Else
                newindex% = False
            End If
        Case "x"
            If Not usedx% Then
                usedx% = True
                newindex% = True
                indexname$ = "Index-X"
            Else
                newindex% = False
            End If
        Case "y"
            If Not usedy% Then
                usedy% = True
                newindex% = True
                indexname$ = "Index-Y"
            Else
                newindex% = False
            End If
        Case "z"
            If Not usedz% Then
                usedz% = True
                newindex% = True
                indexname$ = "Index-Z"
            Else
                newindex% = False
            End If
    End Select
End Sub


Public Sub ResetFlags()
    newindex% = False
    useda% = False
    usea% = False
    usedb% = False
    useb% = False
    usedc% = False
    usec% = False
    usedd% = False
    used% = False
    usede% = False
    usee% = False
    usedf% = False
    usef% = False
    usedg% = False
    useg% = False
    usedh% = False
    useh% = False
    usedi% = False
    usei% = False
    usedj% = False
    usej% = False
    usedk% = False
    usek% = False
    usedl% = False
    usel% = False
    usedm% = False
    usem% = False
    usedn% = False
    usen% = False
    usedo% = False
    useo% = False
    usedp% = False
    usep% = False
    usedq% = False
    useq% = False
    usedr% = False
    user% = False
    useds% = False
    uses% = False
    usedt% = False
    uset% = False
    usedu% = False
    useu% = False
    usedv% = False
    usev% = False
    usedw% = False
    usew% = False
    usedx% = False
    usex% = False
    usedy% = False
    usey% = False
    usedz% = False
    usez% = False
End Sub
